=== debian/changelog ===
plplot (5.9.9-5ubuntu2) saucy; urgency=low

  * Remove build dependency on gdc-v1. Don't pass DC to the build.
  * Add build conflict with libpython3.3-dev (cmake detects 3.x when present).

 -- Matthias Klose <doko@ubuntu.com>  Mon, 01 Jul 2013 20:01:08 +0200

plplot (5.9.9-5ubuntu1) saucy; urgency=low

  * Adjust PYTHON_LIBRARY for multiarch Python.
  * Disable the Ada and D bindings for now, as they won't build.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 30 May 2013 13:47:48 +0100

plplot (5.9.9-5) unstable; urgency=low

  * debian/patches/series, debian/patches/fix-cmake-ada-support.diff:
    Add patch from upstream to fix cmake ada support with cmake 2.8.9 and later
    (closes: #680841).
  * debian/patches/series, debian/patches/fix-lua-includes.diff:
    Add patch to work around problem with lua cmake support. Debian now requires 
    multiple include paths which were not found correctly. This prevents a FTBFS 
    with recent versions of lua5.1.
  * Recompile with latest version of gfortran (closes: #683878). 

 -- Andrew Ross <andrewross@users.sourceforge.net>  Wed, 08 Aug 2012 09:34:10 +0100

plplot (5.9.9-4) unstable; urgency=low

  * debian/rules: 
    + Fix bug in building binary-arch target on autobuilders.  
    + Remove workaround for executable permissions bug in 5.9.8.

 -- Andrew Ross <andrewross@users.sourceforge.net>  Wed, 04 Apr 2012 21:27:11 +0100

plplot (5.9.9-3) unstable; urgency=low

  [ Andrew Ross ]
  * debian/control.in: 
    + Bump standards version to 3.9.3.
    + Fix broken suggests package plplot11-tcl for libplplot11.
    + Remove reference to ada-compiler in libplplot-ada0-dev package as per new 
      Debian Ada policy. Fixes lintian warning.
    + Add note for fortran bindings package description that Fortran 77 support
      is deprecated in the current upstream SVN and will be dropped in a future
      release. New code should use the Fortran 95 bindings.
  * debian/rules: 
    + Tidy up obsolete / unneeded code.
    + Ensure CFLAGS, CXXFLAGS and LDFLAGS are properly exported to cmake. Add in 
      FFLAGS. -fvisibility=hidden and --as-needed should now work properly. The
      latter fixes a lot of dpkg-shlibdeps warnings.
  * debian/patches/series, debian/patches/08_nn_link_libm.diff: Add patch to 
    explicitly link nn library against maths library. Fixes dpkg-shlibdeps 
    warning.
  * Rebuild python-plplot package against new version of numpy as part of the 
    numpy transition.
  
  [ Rafael Laboissiere ]
  * debian/control.in:
    + Build-depend on liboctave-dev
    + Drop build-conflict with octave3.0-headers
    + Depend directly on octave, instead of using the substitution
      variable ${octave:Depends}
  * debian/rules:
    + Set directly the Octave paths, instead of using defs.make
    + Drop the call to octave-depends
  * Adjust the upstream code for working with Octave 3.6.1, by adding the
    following patches:
    + debian/patches/replace-deprecated-split.diff
    + debian/patches/proper-path-handling.diff
    + debian/patches/fix-boolean-operators.diff
  * debian/octave-plplot.files: The path in /usr/lib has now an
    architecture triplet

  [ Andrew Ross ]
  * debian/patches/replace-deprecated-split.diff:
    + Fix use of split in the test_octave.sh test script as well. This plus
      previous changes by Rafael fix octave-3.6 support (closes: #666708).

 -- Andrew Ross <andrewross@users.sourceforge.net>  Mon, 02 Apr 2012 15:30:25 +0100

plplot (5.9.9-2) unstable; urgency=low

  * debian/control.in: Add recommends on cmake for libplplot-dev since
    this provides a better way of building the examples.
  * Force rebuild to fix dependency problems with ada development library
    and gnat-4.6 which make libplplot-ada0-dev uninstallable.
  * Add explicit dependency on gdc-v1 as package is not yet ready for gdc
    version 2 which is the new default with gdc-4.6 (closes: #653088).

 -- Andrew Ross <andrewross@users.sourceforge.net>  Tue, 03 Jan 2012 16:09:55 +0000

plplot (5.9.9-1) unstable; urgency=low

  * New upstream release.
  * debian/patches/series: Remove patches from upstream which are included
    in the new release.
  * debian/control.in:
    + Add back in dependencies (rather than recommends) on the C++
      and fortran libraries. This does pull in extra libraries if you 
      only wish to develop with one language, but reverts to the old 
      behaviour (closes: #642715). 
  * debian/control.in, debian/libplplot-ada0.files,
    debian/libplplot-ada0-dev.files, debian/libplplot-dev, debian/rules,
    debian/README.Debian:
    + Split off ada development files from libplplot-dev package into new
      libplplot-ada0-dev package. Move .ali files from libplplot-ada into
      libplplot-ada0-dev package as per Debian Ada policy. Add explicit
      dependency on ada-compiler, gnat and gnat-4.6 as per policy.
      (closes: #644105, #644110, #644112)
    + Rename libplplot-ada package to libplplot-ada0 so it includes the 
      library soversion as per Debian Ada policy.

 -- Andrew Ross <andrewross@users.sourceforge.net>  Thu, 27 Oct 2011 21:30:38 +0100

plplot (5.9.8-2) unstable; urgency=low

  * debian/control.in: 
    + Change package priority to optional as per policy.
    + Add libplplot-dev dependency on libqsastime-dev (closes: #642146).
    + Fix description for libplplot-dev package (closes: #642122).
  * debian/plplot-tcl-dev.lintian-overrides: Fix lintian overrides.

 -- Andrew Ross <andrewross@users.sourceforge.net>  Mon, 19 Sep 2011 20:38:55 +0100

plplot (5.9.8-1) unstable; urgency=low

  * New upstream release.
  * debian/control.in: Bump standards version to 3.9.2.
  * debian/NEWS: update NEWS file for 5.9.8.
  * debian/control.in, debian/rules, debian/*.files:
    Rename packages to reflect bump in SONAME version.
  * Rebuild against gfortran-4.6 (closes: #635739).
  * debian/rules: 
    + Update to reflect changes in upstream ChangeLog file name. 
    + Tidy up some old comments.

